>From 26d27bb86e952ce52138d8d5fe39ecffa6612212 Mon Sep 17 00:00:00 2001
From: Yuri Chornoivan <yurchor@ukr.net>
Date: Sat, 22 Apr 2017 22:06:20 +0300
Subject: [PATCH] Fix minor typos

---
 docs/formatcaps.html.in      | 2 +-
 docs/formatdomain.html.in    | 2 +-
 src/conf/domain_conf.c       | 2 +-
 src/qemu/qemu_agent.c        | 2 +-
 src/qemu/qemu_command.c      | 4 ++--
 src/qemu/qemu_domain.c       | 2 +-
 src/qemu/qemu_interface.c    | 2 +-
 src/qemu/qemu_monitor_json.c | 2 +-
 8 files changed, 9 insertions(+), 9 deletions(-)

diff --git a/docs/formatcaps.html.in b/docs/formatcaps.html.in
index 57201b5..bc4511c 100644
--- a/docs/formatcaps.html.in
+++ b/docs/formatcaps.html.in
@@ -21,7 +21,7 @@
     command line tool command '<code>capabilities</code>', it dumps the XML
     associated to the current connection. </p>
 
-    <p>As can be seen seen in the <a href="#elementExamples">example</a>, the
+    <p>As can be seen in the <a href="#elementExamples">example</a>, the
     capabilities XML consists of the <code>capabilities</code> element which
     have exactly one <code>host</code> child element to report information on
     host capabilities, and zero or more <code>guest</code> element to express
diff --git a/docs/formatdomain.html.in b/docs/formatdomain.html.in
index 9bea3bc..e31a271 100644
--- a/docs/formatdomain.html.in
+++ b/docs/formatdomain.html.in
@@ -566,7 +566,7 @@
 
         <code>order</code> allows to specify the order to add the online vcpus.
         For hypervisors/platforms that require to insert multiple vcpus at once
-        the order may be be duplicated accross all vcpus that need to be
+        the order may be duplicated accross all vcpus that need to be
         enabled at once. Specifying order is not necessary, vcpus are then
         added in an arbitrary order. If order info is used, it must be used for
         all online vcpus. Hypervisors may clear or update ordering information
diff --git a/src/conf/domain_conf.c b/src/conf/domain_conf.c
index 7d3cf17..fe9b7c7 100644
--- a/src/conf/domain_conf.c
+++ b/src/conf/domain_conf.c
@@ -13993,7 +13993,7 @@ virDomainMemorySourceDefParseXML(xmlNodePtr node,
     case VIR_DOMAIN_MEMORY_MODEL_NVDIMM:
         if (!(def->nvdimmPath = virXPathString("string(./path)", ctxt))) {
             virReportError(VIR_ERR_XML_DETAIL, "%s",
-                           _("path is required for model nvdimm'"));
+                           _("path is required for model 'nvdimm'"));
             goto cleanup;
         }
         break;
diff --git a/src/qemu/qemu_agent.c b/src/qemu/qemu_agent.c
index 46cad53..5d125c4 100644
--- a/src/qemu/qemu_agent.c
+++ b/src/qemu/qemu_agent.c
@@ -872,7 +872,7 @@ void qemuAgentClose(qemuAgentPtr mon)
  * VIR_DOMAIN_QEMU_AGENT_COMMAND_BLOCK(-2), this function will block forever
  * waiting for the result. The value of
  * VIR_DOMAIN_QEMU_AGENT_COMMAND_DEFAULT(-1) means use default timeout value
- * and VIR_DOMAIN_QEMU_AGENT_COMMAND_NOWAIT(0) makes this this function return
+ * and VIR_DOMAIN_QEMU_AGENT_COMMAND_NOWAIT(0) makes this function return
  * immediately without waiting. Any positive value means the number of seconds
  * to wait for the result.
  *
diff --git a/src/qemu/qemu_command.c b/src/qemu/qemu_command.c
index b2e76ca..1116d2c 100644
--- a/src/qemu/qemu_command.c
+++ b/src/qemu/qemu_command.c
@@ -1843,7 +1843,7 @@ qemuBuildDriveStr(virDomainDiskDefPtr disk,
         if (disk->error_policy == VIR_DOMAIN_DISK_ERROR_POLICY_ENOSPACE) {
             /* in the case of enospace, the option is spelled
              * differently in qemu, and it's only valid for werror,
-             * not for rerror, so leave leave rerror NULL.
+             * not for rerror, so leave rerror NULL.
              */
             wpolicy = "enospc";
         } else if (!rpolicy) {
@@ -7242,7 +7242,7 @@ qemuBuildMachineCommandLine(virCommandPtr cmd,
         for (i = 0; i < def->nmems; i++) {
             if (def->mems[i]->model == VIR_DOMAIN_MEMORY_MODEL_NVDIMM) {
                 virReportError(VIR_ERR_CONFIG_UNSUPPORTED, "%s",
-                               _("nvdimm not is not available "
+                               _("nvdimm is not available "
                                  "with this QEMU binary"));
                 return -1;
             }
diff --git a/src/qemu/qemu_domain.c b/src/qemu/qemu_domain.c
index d906fe6..00b0b4a 100644
--- a/src/qemu/qemu_domain.c
+++ b/src/qemu/qemu_domain.c
@@ -8717,7 +8717,7 @@ qemuDomainGetStorageSourceByDevstr(const char *devstr,
 
     if (!disk) {
         virReportError(VIR_ERR_INVALID_ARG,
-                       _("failed to find disk '%s"), target);
+                       _("failed to find disk '%s'"), target);
         goto cleanup;
     }
 
diff --git a/src/qemu/qemu_interface.c b/src/qemu/qemu_interface.c
index 2057ac9..d0850c0 100644
--- a/src/qemu/qemu_interface.c
+++ b/src/qemu/qemu_interface.c
@@ -555,7 +555,7 @@ qemuInterfaceBridgeConnect(virDomainDefPtr def,
             /* libvirt is managing the FDB of the bridge this device
              * is attaching to, so we need to turn off learning and
              * unicast_flood on the device to prevent the kernel from
-             * adding any FDB entries for it. We will add add an fdb
+             * adding any FDB entries for it. We will add an fdb
              * entry ourselves (during qemuInterfaceStartDevices(),
              * using the MAC address from the interface config.
              */
diff --git a/src/qemu/qemu_monitor_json.c b/src/qemu/qemu_monitor_json.c
index aeb777d..98e3c53 100644
--- a/src/qemu/qemu_monitor_json.c
+++ b/src/qemu/qemu_monitor_json.c
@@ -1466,7 +1466,7 @@ qemuMonitorJSONExtractCPUInfo(virJSONValuePtr data,
  * extract results does not produce an error as libvirt can continue without
  * this information.
  *
- * Returns 0 on success success, -1 on a fatal error (oom ...) and -2 if the
+ * Returns 0 on success, -1 on a fatal error (oom ...) and -2 if the
  * query failed gracefully.
  */
 int
-- 
2.7.4