>From 396f39f3b60788bd8440abf3da76f52d74f59e2c Mon Sep 17 00:00:00 2001
From: Boris Fiuczynski <fiuczy@linux.ibm.com>
Date: Thu, 24 Nov 2022 17:24:06 +0100
Subject: [PATCH] To be squashed into patch

Signed-off-by: Boris Fiuczynski <fiuczy@linux.ibm.com>
---
 tests/domaincapsdata/qemu_4.2.0.s390x.xml | 144 +++++++++++-----------
 tests/domaincapsdata/qemu_5.2.0.s390x.xml | 144 +++++++++++-----------
 tests/domaincapsdata/qemu_6.0.0.s390x.xml | 144 +++++++++++-----------
 3 files changed, 216 insertions(+), 216 deletions(-)

diff --git a/tests/domaincapsdata/qemu_4.2.0.s390x.xml b/tests/domaincapsdata/qemu_4.2.0.s390x.xml
index 4f176e2d37..66841881a1 100644
--- a/tests/domaincapsdata/qemu_4.2.0.s390x.xml
+++ b/tests/domaincapsdata/qemu_4.2.0.s390x.xml
@@ -83,79 +83,79 @@
       <feature policy='require' name='cmm'/>
     </mode>
     <mode name='custom' supported='yes'>
-      <model usable='yes' vendor='unknown'>z800-base</model>
-      <model usable='yes' vendor='unknown'>z890.2-base</model>
-      <model usable='yes' vendor='unknown'>z9EC.2</model>
-      <model usable='yes' vendor='unknown'>z13.2</model>
-      <model usable='yes' vendor='unknown'>z9BC-base</model>
-      <model usable='yes' vendor='unknown'>z990.5-base</model>
-      <model usable='yes' vendor='unknown'>z890.2</model>
-      <model usable='yes' vendor='unknown'>z890</model>
-      <model usable='yes' vendor='unknown'>z9BC</model>
-      <model usable='yes' vendor='unknown'>z13</model>
-      <model usable='yes' vendor='unknown'>z196</model>
-      <model usable='yes' vendor='unknown'>z13s</model>
-      <model usable='yes' vendor='unknown'>z990.3</model>
-      <model usable='yes' vendor='unknown'>z13s-base</model>
-      <model usable='yes' vendor='unknown'>z9EC</model>
-      <model usable='yes' vendor='unknown'>gen15a</model>
-      <model usable='yes' vendor='unknown'>z14ZR1-base</model>
-      <model usable='yes' vendor='unknown'>z14.2-base</model>
-      <model usable='yes' vendor='unknown'>z900.3-base</model>
-      <model usable='yes' vendor='unknown'>z13.2-base</model>
-      <model usable='yes' vendor='unknown'>z196.2-base</model>
-      <model usable='yes' vendor='unknown'>zBC12-base</model>
-      <model usable='yes' vendor='unknown'>z9BC.2-base</model>
-      <model usable='yes' vendor='unknown'>z900.2-base</model>
-      <model usable='yes' vendor='unknown'>z9EC.3</model>
-      <model usable='yes' vendor='unknown'>zEC12</model>
-      <model usable='yes' vendor='unknown'>z900</model>
-      <model usable='yes' vendor='unknown'>z114-base</model>
-      <model usable='yes' vendor='unknown'>zEC12-base</model>
-      <model usable='yes' vendor='unknown'>z10EC.2</model>
-      <model usable='yes' vendor='unknown'>z10EC-base</model>
-      <model usable='yes' vendor='unknown'>z900.3</model>
-      <model usable='yes' vendor='unknown'>z14ZR1</model>
-      <model usable='yes' vendor='unknown'>z10BC</model>
-      <model usable='yes' vendor='unknown'>z10BC.2-base</model>
-      <model usable='yes' vendor='unknown'>z990.2</model>
-      <model usable='yes' vendor='unknown'>z9BC.2</model>
-      <model usable='yes' vendor='unknown'>z990</model>
-      <model usable='yes' vendor='unknown'>z14</model>
-      <model usable='yes' vendor='unknown'>gen15b-base</model>
-      <model usable='yes' vendor='unknown'>z990.4</model>
+      <model usable='yes' vendor='IBM'>z800-base</model>
+      <model usable='yes' vendor='IBM'>z890.2-base</model>
+      <model usable='yes' vendor='IBM'>z9EC.2</model>
+      <model usable='yes' vendor='IBM'>z13.2</model>
+      <model usable='yes' vendor='IBM'>z9BC-base</model>
+      <model usable='yes' vendor='IBM'>z990.5-base</model>
+      <model usable='yes' vendor='IBM'>z890.2</model>
+      <model usable='yes' vendor='IBM'>z890</model>
+      <model usable='yes' vendor='IBM'>z9BC</model>
+      <model usable='yes' vendor='IBM'>z13</model>
+      <model usable='yes' vendor='IBM'>z196</model>
+      <model usable='yes' vendor='IBM'>z13s</model>
+      <model usable='yes' vendor='IBM'>z990.3</model>
+      <model usable='yes' vendor='IBM'>z13s-base</model>
+      <model usable='yes' vendor='IBM'>z9EC</model>
+      <model usable='yes' vendor='IBM'>gen15a</model>
+      <model usable='yes' vendor='IBM'>z14ZR1-base</model>
+      <model usable='yes' vendor='IBM'>z14.2-base</model>
+      <model usable='yes' vendor='IBM'>z900.3-base</model>
+      <model usable='yes' vendor='IBM'>z13.2-base</model>
+      <model usable='yes' vendor='IBM'>z196.2-base</model>
+      <model usable='yes' vendor='IBM'>zBC12-base</model>
+      <model usable='yes' vendor='IBM'>z9BC.2-base</model>
+      <model usable='yes' vendor='IBM'>z900.2-base</model>
+      <model usable='yes' vendor='IBM'>z9EC.3</model>
+      <model usable='yes' vendor='IBM'>zEC12</model>
+      <model usable='yes' vendor='IBM'>z900</model>
+      <model usable='yes' vendor='IBM'>z114-base</model>
+      <model usable='yes' vendor='IBM'>zEC12-base</model>
+      <model usable='yes' vendor='IBM'>z10EC.2</model>
+      <model usable='yes' vendor='IBM'>z10EC-base</model>
+      <model usable='yes' vendor='IBM'>z900.3</model>
+      <model usable='yes' vendor='IBM'>z14ZR1</model>
+      <model usable='yes' vendor='IBM'>z10BC</model>
+      <model usable='yes' vendor='IBM'>z10BC.2-base</model>
+      <model usable='yes' vendor='IBM'>z990.2</model>
+      <model usable='yes' vendor='IBM'>z9BC.2</model>
+      <model usable='yes' vendor='IBM'>z990</model>
+      <model usable='yes' vendor='IBM'>z14</model>
+      <model usable='yes' vendor='IBM'>gen15b-base</model>
+      <model usable='yes' vendor='IBM'>z990.4</model>
       <model usable='yes' vendor='unknown'>max</model>
-      <model usable='yes' vendor='unknown'>z10EC.2-base</model>
-      <model usable='yes' vendor='unknown'>gen15a-base</model>
-      <model usable='yes' vendor='unknown'>z800</model>
-      <model usable='yes' vendor='unknown'>zEC12.2</model>
-      <model usable='yes' vendor='unknown'>z10EC</model>
-      <model usable='yes' vendor='unknown'>z990.2-base</model>
-      <model usable='yes' vendor='unknown'>z900-base</model>
-      <model usable='yes' vendor='unknown'>z10BC.2</model>
-      <model usable='yes' vendor='unknown'>z9EC-base</model>
-      <model usable='yes' vendor='unknown'>z9EC.3-base</model>
-      <model usable='yes' vendor='unknown'>z114</model>
-      <model usable='yes' vendor='unknown'>z890.3</model>
-      <model usable='yes' vendor='unknown'>z196-base</model>
-      <model usable='yes' vendor='unknown'>z9EC.2-base</model>
-      <model usable='yes' vendor='unknown'>z196.2</model>
-      <model usable='yes' vendor='unknown'>z14.2</model>
-      <model usable='yes' vendor='unknown'>z990-base</model>
-      <model usable='yes' vendor='unknown'>z900.2</model>
-      <model usable='yes' vendor='unknown'>z890-base</model>
-      <model usable='yes' vendor='unknown'>z10EC.3</model>
-      <model usable='yes' vendor='unknown'>z14-base</model>
-      <model usable='yes' vendor='unknown'>z990.4-base</model>
-      <model usable='yes' vendor='unknown'>z10EC.3-base</model>
-      <model usable='yes' vendor='unknown'>z10BC-base</model>
-      <model usable='yes' vendor='unknown'>z13-base</model>
-      <model usable='yes' vendor='unknown'>z990.3-base</model>
-      <model usable='yes' vendor='unknown'>zEC12.2-base</model>
-      <model usable='yes' vendor='unknown'>zBC12</model>
-      <model usable='yes' vendor='unknown'>z890.3-base</model>
-      <model usable='yes' vendor='unknown'>z990.5</model>
-      <model usable='yes' vendor='unknown'>gen15b</model>
+      <model usable='yes' vendor='IBM'>z10EC.2-base</model>
+      <model usable='yes' vendor='IBM'>gen15a-base</model>
+      <model usable='yes' vendor='IBM'>z800</model>
+      <model usable='yes' vendor='IBM'>zEC12.2</model>
+      <model usable='yes' vendor='IBM'>z10EC</model>
+      <model usable='yes' vendor='IBM'>z990.2-base</model>
+      <model usable='yes' vendor='IBM'>z900-base</model>
+      <model usable='yes' vendor='IBM'>z10BC.2</model>
+      <model usable='yes' vendor='IBM'>z9EC-base</model>
+      <model usable='yes' vendor='IBM'>z9EC.3-base</model>
+      <model usable='yes' vendor='IBM'>z114</model>
+      <model usable='yes' vendor='IBM'>z890.3</model>
+      <model usable='yes' vendor='IBM'>z196-base</model>
+      <model usable='yes' vendor='IBM'>z9EC.2-base</model>
+      <model usable='yes' vendor='IBM'>z196.2</model>
+      <model usable='yes' vendor='IBM'>z14.2</model>
+      <model usable='yes' vendor='IBM'>z990-base</model>
+      <model usable='yes' vendor='IBM'>z900.2</model>
+      <model usable='yes' vendor='IBM'>z890-base</model>
+      <model usable='yes' vendor='IBM'>z10EC.3</model>
+      <model usable='yes' vendor='IBM'>z14-base</model>
+      <model usable='yes' vendor='IBM'>z990.4-base</model>
+      <model usable='yes' vendor='IBM'>z10EC.3-base</model>
+      <model usable='yes' vendor='IBM'>z10BC-base</model>
+      <model usable='yes' vendor='IBM'>z13-base</model>
+      <model usable='yes' vendor='IBM'>z990.3-base</model>
+      <model usable='yes' vendor='IBM'>zEC12.2-base</model>
+      <model usable='yes' vendor='IBM'>zBC12</model>
+      <model usable='yes' vendor='IBM'>z890.3-base</model>
+      <model usable='yes' vendor='IBM'>z990.5</model>
+      <model usable='yes' vendor='IBM'>gen15b</model>
       <model usable='no' vendor='unknown'>qemu</model>
     </mode>
   </cpu>
diff --git a/tests/domaincapsdata/qemu_5.2.0.s390x.xml b/tests/domaincapsdata/qemu_5.2.0.s390x.xml
index 760f514d7b..31ddbfbc75 100644
--- a/tests/domaincapsdata/qemu_5.2.0.s390x.xml
+++ b/tests/domaincapsdata/qemu_5.2.0.s390x.xml
@@ -85,79 +85,79 @@
       <feature policy='require' name='cmm'/>
     </mode>
     <mode name='custom' supported='yes'>
-      <model usable='yes' vendor='unknown'>z800-base</model>
-      <model usable='yes' vendor='unknown'>z890.2-base</model>
-      <model usable='yes' vendor='unknown'>z9EC.2</model>
-      <model usable='yes' vendor='unknown'>z13.2</model>
-      <model usable='yes' vendor='unknown'>z990.5-base</model>
-      <model usable='yes' vendor='unknown'>z9BC-base</model>
-      <model usable='yes' vendor='unknown'>z890.2</model>
-      <model usable='yes' vendor='unknown'>z890</model>
-      <model usable='yes' vendor='unknown'>z9BC</model>
-      <model usable='yes' vendor='unknown'>z13</model>
-      <model usable='yes' vendor='unknown'>z196</model>
-      <model usable='yes' vendor='unknown'>z13s</model>
-      <model usable='yes' vendor='unknown'>z990.3</model>
-      <model usable='yes' vendor='unknown'>z13s-base</model>
-      <model usable='yes' vendor='unknown'>z9EC</model>
-      <model usable='yes' vendor='unknown'>gen15a</model>
-      <model usable='yes' vendor='unknown'>z14ZR1-base</model>
-      <model usable='yes' vendor='unknown'>z14.2-base</model>
-      <model usable='yes' vendor='unknown'>z900.3-base</model>
-      <model usable='yes' vendor='unknown'>z13.2-base</model>
-      <model usable='yes' vendor='unknown'>z196.2-base</model>
-      <model usable='yes' vendor='unknown'>zBC12-base</model>
-      <model usable='yes' vendor='unknown'>z9BC.2-base</model>
-      <model usable='yes' vendor='unknown'>z900.2-base</model>
-      <model usable='yes' vendor='unknown'>z9EC.3</model>
-      <model usable='yes' vendor='unknown'>zEC12</model>
-      <model usable='yes' vendor='unknown'>z900</model>
-      <model usable='yes' vendor='unknown'>z114-base</model>
-      <model usable='yes' vendor='unknown'>zEC12-base</model>
-      <model usable='yes' vendor='unknown'>z10EC.2</model>
-      <model usable='yes' vendor='unknown'>z10EC-base</model>
-      <model usable='yes' vendor='unknown'>z900.3</model>
-      <model usable='yes' vendor='unknown'>z14ZR1</model>
-      <model usable='yes' vendor='unknown'>z10BC</model>
-      <model usable='yes' vendor='unknown'>z10BC.2-base</model>
-      <model usable='yes' vendor='unknown'>z9BC.2</model>
-      <model usable='yes' vendor='unknown'>z990</model>
-      <model usable='yes' vendor='unknown'>z990.2</model>
-      <model usable='yes' vendor='unknown'>z14</model>
-      <model usable='yes' vendor='unknown'>gen15b-base</model>
-      <model usable='yes' vendor='unknown'>z990.4</model>
+      <model usable='yes' vendor='IBM'>z800-base</model>
+      <model usable='yes' vendor='IBM'>z890.2-base</model>
+      <model usable='yes' vendor='IBM'>z9EC.2</model>
+      <model usable='yes' vendor='IBM'>z13.2</model>
+      <model usable='yes' vendor='IBM'>z990.5-base</model>
+      <model usable='yes' vendor='IBM'>z9BC-base</model>
+      <model usable='yes' vendor='IBM'>z890.2</model>
+      <model usable='yes' vendor='IBM'>z890</model>
+      <model usable='yes' vendor='IBM'>z9BC</model>
+      <model usable='yes' vendor='IBM'>z13</model>
+      <model usable='yes' vendor='IBM'>z196</model>
+      <model usable='yes' vendor='IBM'>z13s</model>
+      <model usable='yes' vendor='IBM'>z990.3</model>
+      <model usable='yes' vendor='IBM'>z13s-base</model>
+      <model usable='yes' vendor='IBM'>z9EC</model>
+      <model usable='yes' vendor='IBM'>gen15a</model>
+      <model usable='yes' vendor='IBM'>z14ZR1-base</model>
+      <model usable='yes' vendor='IBM'>z14.2-base</model>
+      <model usable='yes' vendor='IBM'>z900.3-base</model>
+      <model usable='yes' vendor='IBM'>z13.2-base</model>
+      <model usable='yes' vendor='IBM'>z196.2-base</model>
+      <model usable='yes' vendor='IBM'>zBC12-base</model>
+      <model usable='yes' vendor='IBM'>z9BC.2-base</model>
+      <model usable='yes' vendor='IBM'>z900.2-base</model>
+      <model usable='yes' vendor='IBM'>z9EC.3</model>
+      <model usable='yes' vendor='IBM'>zEC12</model>
+      <model usable='yes' vendor='IBM'>z900</model>
+      <model usable='yes' vendor='IBM'>z114-base</model>
+      <model usable='yes' vendor='IBM'>zEC12-base</model>
+      <model usable='yes' vendor='IBM'>z10EC.2</model>
+      <model usable='yes' vendor='IBM'>z10EC-base</model>
+      <model usable='yes' vendor='IBM'>z900.3</model>
+      <model usable='yes' vendor='IBM'>z14ZR1</model>
+      <model usable='yes' vendor='IBM'>z10BC</model>
+      <model usable='yes' vendor='IBM'>z10BC.2-base</model>
+      <model usable='yes' vendor='IBM'>z9BC.2</model>
+      <model usable='yes' vendor='IBM'>z990</model>
+      <model usable='yes' vendor='IBM'>z990.2</model>
+      <model usable='yes' vendor='IBM'>z14</model>
+      <model usable='yes' vendor='IBM'>gen15b-base</model>
+      <model usable='yes' vendor='IBM'>z990.4</model>
       <model usable='yes' vendor='unknown'>max</model>
-      <model usable='yes' vendor='unknown'>z990.2-base</model>
-      <model usable='yes' vendor='unknown'>z10EC.2-base</model>
-      <model usable='yes' vendor='unknown'>gen15a-base</model>
-      <model usable='yes' vendor='unknown'>z800</model>
-      <model usable='yes' vendor='unknown'>z10EC</model>
-      <model usable='yes' vendor='unknown'>zEC12.2</model>
-      <model usable='yes' vendor='unknown'>z900-base</model>
-      <model usable='yes' vendor='unknown'>z10BC.2</model>
-      <model usable='yes' vendor='unknown'>z9EC-base</model>
-      <model usable='yes' vendor='unknown'>z9EC.3-base</model>
-      <model usable='yes' vendor='unknown'>z114</model>
-      <model usable='yes' vendor='unknown'>z890.3</model>
-      <model usable='yes' vendor='unknown'>z196-base</model>
-      <model usable='yes' vendor='unknown'>z9EC.2-base</model>
-      <model usable='yes' vendor='unknown'>z196.2</model>
-      <model usable='yes' vendor='unknown'>z14.2</model>
-      <model usable='yes' vendor='unknown'>z990-base</model>
-      <model usable='yes' vendor='unknown'>z900.2</model>
-      <model usable='yes' vendor='unknown'>z10EC.3</model>
-      <model usable='yes' vendor='unknown'>z890-base</model>
-      <model usable='yes' vendor='unknown'>z14-base</model>
-      <model usable='yes' vendor='unknown'>z990.4-base</model>
-      <model usable='yes' vendor='unknown'>z10EC.3-base</model>
-      <model usable='yes' vendor='unknown'>z10BC-base</model>
-      <model usable='yes' vendor='unknown'>z13-base</model>
-      <model usable='yes' vendor='unknown'>z990.3-base</model>
-      <model usable='yes' vendor='unknown'>zEC12.2-base</model>
-      <model usable='yes' vendor='unknown'>zBC12</model>
-      <model usable='yes' vendor='unknown'>z890.3-base</model>
-      <model usable='yes' vendor='unknown'>z990.5</model>
-      <model usable='yes' vendor='unknown'>gen15b</model>
+      <model usable='yes' vendor='IBM'>z990.2-base</model>
+      <model usable='yes' vendor='IBM'>z10EC.2-base</model>
+      <model usable='yes' vendor='IBM'>gen15a-base</model>
+      <model usable='yes' vendor='IBM'>z800</model>
+      <model usable='yes' vendor='IBM'>z10EC</model>
+      <model usable='yes' vendor='IBM'>zEC12.2</model>
+      <model usable='yes' vendor='IBM'>z900-base</model>
+      <model usable='yes' vendor='IBM'>z10BC.2</model>
+      <model usable='yes' vendor='IBM'>z9EC-base</model>
+      <model usable='yes' vendor='IBM'>z9EC.3-base</model>
+      <model usable='yes' vendor='IBM'>z114</model>
+      <model usable='yes' vendor='IBM'>z890.3</model>
+      <model usable='yes' vendor='IBM'>z196-base</model>
+      <model usable='yes' vendor='IBM'>z9EC.2-base</model>
+      <model usable='yes' vendor='IBM'>z196.2</model>
+      <model usable='yes' vendor='IBM'>z14.2</model>
+      <model usable='yes' vendor='IBM'>z990-base</model>
+      <model usable='yes' vendor='IBM'>z900.2</model>
+      <model usable='yes' vendor='IBM'>z10EC.3</model>
+      <model usable='yes' vendor='IBM'>z890-base</model>
+      <model usable='yes' vendor='IBM'>z14-base</model>
+      <model usable='yes' vendor='IBM'>z990.4-base</model>
+      <model usable='yes' vendor='IBM'>z10EC.3-base</model>
+      <model usable='yes' vendor='IBM'>z10BC-base</model>
+      <model usable='yes' vendor='IBM'>z13-base</model>
+      <model usable='yes' vendor='IBM'>z990.3-base</model>
+      <model usable='yes' vendor='IBM'>zEC12.2-base</model>
+      <model usable='yes' vendor='IBM'>zBC12</model>
+      <model usable='yes' vendor='IBM'>z890.3-base</model>
+      <model usable='yes' vendor='IBM'>z990.5</model>
+      <model usable='yes' vendor='IBM'>gen15b</model>
       <model usable='yes' vendor='unknown'>qemu</model>
     </mode>
   </cpu>
diff --git a/tests/domaincapsdata/qemu_6.0.0.s390x.xml b/tests/domaincapsdata/qemu_6.0.0.s390x.xml
index b1968668db..1cb19e051b 100644
--- a/tests/domaincapsdata/qemu_6.0.0.s390x.xml
+++ b/tests/domaincapsdata/qemu_6.0.0.s390x.xml
@@ -86,79 +86,79 @@
       <feature policy='require' name='cmm'/>
     </mode>
     <mode name='custom' supported='yes'>
-      <model usable='yes' vendor='unknown'>z800-base</model>
-      <model usable='yes' vendor='unknown'>z890.2-base</model>
-      <model usable='yes' vendor='unknown'>z9EC.2</model>
-      <model usable='yes' vendor='unknown'>z13.2</model>
-      <model usable='yes' vendor='unknown'>z990.5-base</model>
-      <model usable='yes' vendor='unknown'>z9BC-base</model>
-      <model usable='yes' vendor='unknown'>z890.2</model>
-      <model usable='yes' vendor='unknown'>z890</model>
-      <model usable='yes' vendor='unknown'>z9BC</model>
-      <model usable='yes' vendor='unknown'>z13</model>
-      <model usable='yes' vendor='unknown'>z196</model>
-      <model usable='yes' vendor='unknown'>z13s</model>
-      <model usable='yes' vendor='unknown'>z990.3</model>
-      <model usable='yes' vendor='unknown'>z13s-base</model>
-      <model usable='yes' vendor='unknown'>z9EC</model>
-      <model usable='yes' vendor='unknown'>gen15a</model>
-      <model usable='yes' vendor='unknown'>z14ZR1-base</model>
-      <model usable='yes' vendor='unknown'>z14.2-base</model>
-      <model usable='yes' vendor='unknown'>z900.3-base</model>
-      <model usable='yes' vendor='unknown'>z13.2-base</model>
-      <model usable='yes' vendor='unknown'>z196.2-base</model>
-      <model usable='yes' vendor='unknown'>zBC12-base</model>
-      <model usable='yes' vendor='unknown'>z9BC.2-base</model>
-      <model usable='yes' vendor='unknown'>z900.2-base</model>
-      <model usable='yes' vendor='unknown'>z9EC.3</model>
-      <model usable='yes' vendor='unknown'>zEC12</model>
-      <model usable='yes' vendor='unknown'>z900</model>
-      <model usable='yes' vendor='unknown'>z114-base</model>
-      <model usable='yes' vendor='unknown'>zEC12-base</model>
-      <model usable='yes' vendor='unknown'>z10EC.2</model>
-      <model usable='yes' vendor='unknown'>z10EC-base</model>
-      <model usable='yes' vendor='unknown'>z900.3</model>
-      <model usable='yes' vendor='unknown'>z14ZR1</model>
-      <model usable='yes' vendor='unknown'>z10BC</model>
-      <model usable='yes' vendor='unknown'>z10BC.2-base</model>
-      <model usable='yes' vendor='unknown'>z9BC.2</model>
-      <model usable='yes' vendor='unknown'>z990</model>
-      <model usable='yes' vendor='unknown'>z990.2</model>
-      <model usable='yes' vendor='unknown'>z14</model>
-      <model usable='yes' vendor='unknown'>gen15b-base</model>
-      <model usable='yes' vendor='unknown'>z990.4</model>
+      <model usable='yes' vendor='IBM'>z800-base</model>
+      <model usable='yes' vendor='IBM'>z890.2-base</model>
+      <model usable='yes' vendor='IBM'>z9EC.2</model>
+      <model usable='yes' vendor='IBM'>z13.2</model>
+      <model usable='yes' vendor='IBM'>z990.5-base</model>
+      <model usable='yes' vendor='IBM'>z9BC-base</model>
+      <model usable='yes' vendor='IBM'>z890.2</model>
+      <model usable='yes' vendor='IBM'>z890</model>
+      <model usable='yes' vendor='IBM'>z9BC</model>
+      <model usable='yes' vendor='IBM'>z13</model>
+      <model usable='yes' vendor='IBM'>z196</model>
+      <model usable='yes' vendor='IBM'>z13s</model>
+      <model usable='yes' vendor='IBM'>z990.3</model>
+      <model usable='yes' vendor='IBM'>z13s-base</model>
+      <model usable='yes' vendor='IBM'>z9EC</model>
+      <model usable='yes' vendor='IBM'>gen15a</model>
+      <model usable='yes' vendor='IBM'>z14ZR1-base</model>
+      <model usable='yes' vendor='IBM'>z14.2-base</model>
+      <model usable='yes' vendor='IBM'>z900.3-base</model>
+      <model usable='yes' vendor='IBM'>z13.2-base</model>
+      <model usable='yes' vendor='IBM'>z196.2-base</model>
+      <model usable='yes' vendor='IBM'>zBC12-base</model>
+      <model usable='yes' vendor='IBM'>z9BC.2-base</model>
+      <model usable='yes' vendor='IBM'>z900.2-base</model>
+      <model usable='yes' vendor='IBM'>z9EC.3</model>
+      <model usable='yes' vendor='IBM'>zEC12</model>
+      <model usable='yes' vendor='IBM'>z900</model>
+      <model usable='yes' vendor='IBM'>z114-base</model>
+      <model usable='yes' vendor='IBM'>zEC12-base</model>
+      <model usable='yes' vendor='IBM'>z10EC.2</model>
+      <model usable='yes' vendor='IBM'>z10EC-base</model>
+      <model usable='yes' vendor='IBM'>z900.3</model>
+      <model usable='yes' vendor='IBM'>z14ZR1</model>
+      <model usable='yes' vendor='IBM'>z10BC</model>
+      <model usable='yes' vendor='IBM'>z10BC.2-base</model>
+      <model usable='yes' vendor='IBM'>z9BC.2</model>
+      <model usable='yes' vendor='IBM'>z990</model>
+      <model usable='yes' vendor='IBM'>z990.2</model>
+      <model usable='yes' vendor='IBM'>z14</model>
+      <model usable='yes' vendor='IBM'>gen15b-base</model>
+      <model usable='yes' vendor='IBM'>z990.4</model>
       <model usable='yes' vendor='unknown'>max</model>
-      <model usable='yes' vendor='unknown'>z10EC.2-base</model>
-      <model usable='yes' vendor='unknown'>gen15a-base</model>
-      <model usable='yes' vendor='unknown'>z800</model>
-      <model usable='yes' vendor='unknown'>z10EC</model>
-      <model usable='yes' vendor='unknown'>zEC12.2</model>
-      <model usable='yes' vendor='unknown'>z990.2-base</model>
-      <model usable='yes' vendor='unknown'>z900-base</model>
-      <model usable='yes' vendor='unknown'>z10BC.2</model>
-      <model usable='yes' vendor='unknown'>z9EC-base</model>
-      <model usable='yes' vendor='unknown'>z9EC.3-base</model>
-      <model usable='yes' vendor='unknown'>z114</model>
-      <model usable='yes' vendor='unknown'>z890.3</model>
-      <model usable='yes' vendor='unknown'>z196-base</model>
-      <model usable='yes' vendor='unknown'>z9EC.2-base</model>
-      <model usable='yes' vendor='unknown'>z196.2</model>
-      <model usable='yes' vendor='unknown'>z14.2</model>
-      <model usable='yes' vendor='unknown'>z990-base</model>
-      <model usable='yes' vendor='unknown'>z900.2</model>
-      <model usable='yes' vendor='unknown'>z890-base</model>
-      <model usable='yes' vendor='unknown'>z10EC.3</model>
-      <model usable='yes' vendor='unknown'>z14-base</model>
-      <model usable='yes' vendor='unknown'>z990.4-base</model>
-      <model usable='yes' vendor='unknown'>z10EC.3-base</model>
-      <model usable='yes' vendor='unknown'>z10BC-base</model>
-      <model usable='yes' vendor='unknown'>z13-base</model>
-      <model usable='yes' vendor='unknown'>z990.3-base</model>
-      <model usable='yes' vendor='unknown'>zEC12.2-base</model>
-      <model usable='yes' vendor='unknown'>zBC12</model>
-      <model usable='yes' vendor='unknown'>z890.3-base</model>
-      <model usable='yes' vendor='unknown'>z990.5</model>
-      <model usable='yes' vendor='unknown'>gen15b</model>
+      <model usable='yes' vendor='IBM'>z10EC.2-base</model>
+      <model usable='yes' vendor='IBM'>gen15a-base</model>
+      <model usable='yes' vendor='IBM'>z800</model>
+      <model usable='yes' vendor='IBM'>z10EC</model>
+      <model usable='yes' vendor='IBM'>zEC12.2</model>
+      <model usable='yes' vendor='IBM'>z990.2-base</model>
+      <model usable='yes' vendor='IBM'>z900-base</model>
+      <model usable='yes' vendor='IBM'>z10BC.2</model>
+      <model usable='yes' vendor='IBM'>z9EC-base</model>
+      <model usable='yes' vendor='IBM'>z9EC.3-base</model>
+      <model usable='yes' vendor='IBM'>z114</model>
+      <model usable='yes' vendor='IBM'>z890.3</model>
+      <model usable='yes' vendor='IBM'>z196-base</model>
+      <model usable='yes' vendor='IBM'>z9EC.2-base</model>
+      <model usable='yes' vendor='IBM'>z196.2</model>
+      <model usable='yes' vendor='IBM'>z14.2</model>
+      <model usable='yes' vendor='IBM'>z990-base</model>
+      <model usable='yes' vendor='IBM'>z900.2</model>
+      <model usable='yes' vendor='IBM'>z890-base</model>
+      <model usable='yes' vendor='IBM'>z10EC.3</model>
+      <model usable='yes' vendor='IBM'>z14-base</model>
+      <model usable='yes' vendor='IBM'>z990.4-base</model>
+      <model usable='yes' vendor='IBM'>z10EC.3-base</model>
+      <model usable='yes' vendor='IBM'>z10BC-base</model>
+      <model usable='yes' vendor='IBM'>z13-base</model>
+      <model usable='yes' vendor='IBM'>z990.3-base</model>
+      <model usable='yes' vendor='IBM'>zEC12.2-base</model>
+      <model usable='yes' vendor='IBM'>zBC12</model>
+      <model usable='yes' vendor='IBM'>z890.3-base</model>
+      <model usable='yes' vendor='IBM'>z990.5</model>
+      <model usable='yes' vendor='IBM'>gen15b</model>
       <model usable='yes' vendor='unknown'>qemu</model>
     </mode>
   </cpu>
-- 
2.36.1